#!/usr/local/bin/python

# chdir
from os import chdir
from sys import path
chdir(path[0])

from beebb.bb_sql import Session, TrialEmail, TrialUser, TrialReset
from beebb.bb_conf import rc
from time import time
from thief_grr import str2secs

# session janitor
for session in list(Session.select()):
	if time() - session.lastused > str2secs(rc['max_session_idle']):
		session.terminate()

# trialemail janitor
for trialemail in list(TrialEmail.select()):
	if time() - trialemail.created > str2secs(rc['max_trialemail_idle']):
		trialemail.cancel(reason="Request timed out!")

# trialuser janitor
for trialuser in list(TrialUser.select()):
	if time() - trialuser.created > str2secs(rc['max_trialuser_idle']):
		trialuser.cancel(reason="Request timed out!")

# trialreset janitor
for trialreset in list(TrialReset.select()):
	if time() - trialreset.created > str2secs(rc['max_trialreset_idle']):
		trialreset.cancel(reason="Request timed out!")
