#!/usr/local/bin/python


import beebb.bb_debug

from beebb import bb_html, bb_sql, bb_mail, bb_http
from beebb.bb_error import BeeBBError
from thief_grr.http import getPOST, getIP
from thief_grr import easydict, randstr, MD5
import string


POST = easydict(getPOST(), default='')


bb_http.membersonly()


user = bb_http.bbSession().getUser()
email = POST['email'].strip().lower()
oldpasswd = POST['oldpasswd']
passwd = POST['passwd']
confirm = POST['confirm']


# details
details = {}
details['firstname'] = POST['firstname']
details['lastname'] = POST['lastname']
details['location'] = POST['location']
details['about'] = POST['about']
details['website'] = POST['website']
details['publicemail'] = POST['publicemail']
details['signature'] = POST['signature']
details['photo'] = POST['photo']
details['avatar'] = POST['avatar']



def validate_passwd():
	if not oldpasswd:
		raise BeeBBError, "You must enter your existing password in order to change it."
	if not user.hasPasswd(oldpasswd):
		raise BeeBBError, "Nope, that wasn't your password...  Really..."
	if len(passwd) < 8:
		raise BeeBBError, "Password must be at least 8 characters long."
	if passwd != confirm:
		raise BeeBBError, "Passwords mismatch"


website = bb_html.Account()


if email:

	# Update options
	if POST['accept_messages']:
		user.setOption('accept_messages', True)
	else:
		user.setOption('accept_messages', False)

	# Handle images
	details['photo'] = user.usePhoto(details['photo'])
	details['avatar'] = user.useAvatar(details['avatar'])

	# Update details
	if not user.details:
		bb_sql.UserDetails(user=user)
	for detail in details:
		setattr(user.details, detail, details[detail])
	website.addTop("Details updated!")

	# Check if email has changed
	if email != user.email:
		try:
			user.changeEmail(email)
		except Exception, e:
			website.addTop(str(e), css="error")
		else:
			website.addTop("An email has been sent to the new address of yours.  Follow instructions there to complete the change.")

	# Check if there is a new passwd
	if oldpasswd or passwd or confirm:
		try:
			validate_passwd()
		except BeeBBError, e:
			website.addTop(unicode(e), css="error")
		else:
			user.passwd = MD5(passwd)
			website.addTop("Password updated successfully")




# Print

website.send()
