#!/usr/local/bin/python


import beebb.bb_debug

from os import environ
from beebb import bb_html, bb_sql, bb_http
from beebb.bb_error import BeeBBError
from thief_grr.http import getPOST, getGET
from thief_grr import easydict


user = bb_http.membersonly()


method = environ.get("REQUEST_METHOD")

# Was there a POST or a GET?
if method == 'POST':
	VARS = easydict(getPOST(), default='')
	fire = VARS['fire']
	hire = VARS['hire']
	newtitle = VARS['title']
	newdescr = VARS['descr']
	newrlevel = float(VARS['rlevel'])
	newwlevel = float(VARS['wlevel'])
	newprec = float(VARS['prec'])
	if not fire:
		fire = []
	if not hire:
		hire = []
	if not (type(fire) is list):
		fire = [fire]
	if not (type(hire) is list):
		hire = [hire]
else:
	VARS = easydict(getGET(), default='')

boardid = VARS['board']

try:
	try:
		board = bb_sql.Board.get(boardid)
	except Exception, e:
		raise BeeBBError, "No such board."
	
	bb_http.must(user.canAdministrateBoard(board))

	# No POST vars at all
	if method != 'POST':
		website = bb_html.Admin(board)

	# Some data was POST'ed
	else:
		website = bb_html.Admin(board)

		# title
		try:
			if board.title != newtitle:
				website.addTop('''Changed board's title from "%s" to "%s".''' % (board.title, newtitle))
				board.title = newtitle
		except Exception, e:
			raise BeeBBError, "Database problem with board's title.  I stop."

		# descr
		try:
			if board.descr != newdescr:
				website.addTop('''Changed board's description from "%s" to "%s".''' % (board.descr, newtitle))
				board.descr = newdescr
		except Exception, e:
			raise BeeBBError, "Database problem with board's description.  I stop."

		# rlevel
		try:
			if board.rlevel != newrlevel:
				website.addTop('''Changed board's read level from %f to %f.''' % (board.rlevel, newrlevel))
				board.rlevel = newrlevel
		except Exception, e:
			raise BeeBBError, "Database problem with board's read level."

		# wlevel
		try:
			if board.wlevel != newwlevel:
				website.addTop('''Changed board's write level from %f to %f.''' % (board.wlevel, newwlevel))
				board.wlevel = newwlevel
		except Exception, e:
			raise BeeBBError, "Database problem with board's write level."

		# prec
		try:
			if board.prec != newprec:
				website.addTop('''Changed board's prec from %f to %f.''' % (board.prec, newprec))
				board.prec = newprec
		except Exception, e:
			raise BeeBBError, "Database problem with board's precedence number."

		# hire
		for peasant in hire:
			try:
				u = bb_sql.User.byUsername(peasant)
				if not u.isreal:
					website.addTop('''%s is a virtual user, NOT for hire!''' % u.fullname)
				elif board not in u.boards:
					u.addBoard(board)
					website.addTop('''Hired %s.''' % peasant)
			except Exception, e:
				raise BeeBBError, "Database problem hiring peasant %s.  I stop." % peasant

		# fire
		for moderator in fire:
			try:
				u = bb_sql.User.byUsername(moderator)
				if u in board.moderators:
					u.removeBoard(board)
					website.addTop("Fired %s." % moderator)
			except Exception, e:
				raise BeeBBError, "Database problem firing moderator %s.  Are you sure you didn't try anything funny?" % moderator

except BeeBBError, e:
	website = bb_html.Generic(message=unicode(e))


# Print

website.send()
