#!/usr/local/bin/python


import beebb.bb_debug

from beebb import bb_html, bb_sql, bb_mail
from beebb.bb_error import BeeBBError
from thief_grr.http import getGET, getIP
from thief_grr import easydict


GET = easydict(getGET(), default='')


key = GET['key']
what = GET['what']
ip = getIP()


def validate():

	# Does this key exist in the corresponding Trial table?
	try:
		if what == 'user':
			trial = bb_sql.TrialUser.byKey(key)
			success = '''You have successfully registered your account.  You may <a href="login.py" title="Log in">use it</a>.  Go!'''
		elif what == 'email':
			trial = bb_sql.TrialEmail.byKey(key)
			success = '''Your email address has been updated.'''
		elif what == 'reset':
			trial = bb_sql.TrialReset.byKey(key)
			success = '''Your password has been reset.  <a href="login.py" title="Log in">Log in</a>...'''
		else:
			raise BeeBBError, "Ok, you want me to confirm... something... But what?!"
		return (trial, success)
	except Exception, e:
		raise BeeBBError, "Wrong key.  Try again.  You have a lot of chances of succeeding at random."

	# Is the IP address correct?
	else:
		if ip != trial.ip:
			raise BeeBBError, "Your IP address, %s, does not match the one who made the request.  Sorry." % ip



# Does everything look ok?
try:
	trial, success = validate()
# Found a catch!
except BeeBBError, e:
	website = bb_html.Generic(message=unicode(e), css="error")
# All _seems_ valid
else:
	trial.ok()
	website = bb_html.Generic(message=success)



# Print

website.send()
