#!/usr/local/bin/python


import beebb.bb_debug

from os import environ
from beebb import bb_html, bb_sql, bb_http
from beebb.bb_error import BeeBBError
from thief_grr.http import getPOST, getGET
from thief_grr import easydict, randstr


user = bb_http.membersonly()

method = environ.get("REQUEST_METHOD")

# Was there a POST or a GET?
if method == 'POST':
	VARS = easydict(getPOST(), default='')
	title = VARS['title']
	descr = VARS['descr']
	parentid = VARS['parent']
	try:
		rlevel = float(VARS['rlevel'])
	except ValueError:
		rlevel = 1.0
	try:
		wlevel = float(VARS['wlevel'])
	except ValueError:
		wlevel = 1.0
	try:
		if parentid:
			parent = bb_sql.Board.get(parentid)
			board = user.createBoard(parent=parent, title=title, descr=descr, rlevel=rlevel, wlevel=wlevel)
		else:
			raise BeeBBError, "You must specify a parent-board."
	except BeeBBError, e:
		website = bb_html.Generic(message=unicode(e))
	except Exception, e:
		website = bb_html.Generic(message=unicode(e))
	else:
		website = bb_html.Generic(message='''Board %s created succesfully.  <a href="index.py?board=%d">Check</a>/<a href="admin.py?board=%d">administrate</a> it, or <a href="dbboard.py?parent=%d" title="Create a new sub-board of %s">create</a> another sub-board here...''' % (board.title, board.id, board.id, board.parent.id, board.parent.title))
	

else:
	VARS = easydict(getGET(), default='')
	parentid = VARS['parent']
	try:
		if parentid:
			parent = bb_sql.Board.get(parentid)
			website = bb_html.Dbboard(parent=parent)
		else:
			raise BeeBBError, "You must specify a parent-board..."
	except BeeBBError, e:
		website = bb_html.Generic(message=unicode(e))
	except Exception, e:
		website = bb_html.Generic(message=unicode(e))



# Print

website.send()
