#!/usr/local/bin/python


import beebb.bb_debug

from os import environ
from beebb import bb_html, bb_sql, bb_http
from beebb.bb_error import BeeBBError
from thief_grr.http import getPOST, getGET
from thief_grr import easydict, randstr


user = bb_http.membersonly()

method = environ.get("REQUEST_METHOD")

# Was there a POST or a GET?
if method == 'POST':
	POST = easydict(getPOST(), default='')
	head = POST['head']
	body = POST['body']
	boardid = POST['board']
	threadid = POST['thread']
	postid = POST['post']
	try:
		# new thread
		if boardid:
			board = bb_sql.Board.get(boardid)
			# we need head here, just to check that it isn't empty
			thread = user.createThread(board=board, head=head)
			post = user.createPost(thread=thread, head=head, body=body)
		# reply
		elif threadid:
			thread = bb_sql.Thread.get(threadid)
			post = user.createPost(thread=thread, head=head, body=body)
		# edit
		elif postid:
			post = bb_sql.Post.get(postid)
			if user.canEditPost(post):
				post.head = head
				post.body = body
				# this post is no longer a 'new' post
				for session in post.sessions:
					if user is not session.user:
						session.removePost(post)
			else:
				raise BeeBBError, "Permission denied.  Ha!"
		else:
			raise BeeBBError, "You must specify either a thread or a board, or a post to edit."
	except BeeBBError, e:
		website = bb_html.Generic(message=unicode(e))
	except Exception, e:
		website = bb_html.Generic(message=unicode(e))
	else:
		website = bb_html.Generic(message='''Message posted.  <a href="thread.py?post=%d#post%d">Read</a> it...''' % (post.id, post.id))
	

else:
	GET = easydict(getGET(), default='')
	boardid = GET['board']
	threadid = GET['thread']
	postid = GET['post']
	try:
		if boardid:
			board = bb_sql.Board.get(boardid)
			website = bb_html.Dbpost(board=board)
		elif threadid:
			thread = bb_sql.Thread.get(threadid)
			website = bb_html.Dbpost(thread=thread)
		elif postid:
			post = bb_sql.Post.get(postid)
			website = bb_html.Dbpost(post=post)
		else:
			raise BeeBBError, "You must specify either a thread or a board, or a post to edit..."
	except BeeBBError, e:
		website = bb_html.Generic(message=unicode(e))
	except Exception, e:
		website = bb_html.Generic(message=unicode(e))



# Print

website.send()
