#!/usr/local/bin/python


import beebb.bb_debug

from beebb import bb_html, bb_sql, bb_http, bb_mail
from beebb.bb_error import BeeBBError
from beebb.bb_conf import rc
from beebb.bb_valid import *
from thief_grr.http import getPOST, getIP
from thief_grr import easydict, randstr, MD5
import string


POST = easydict(getPOST(), default='')


bb_http.guestsonly()


username = POST['username'].strip().lower()
email = POST['email'].strip().lower()
passwd = POST['passwd']
confirm = POST['confirm']
key = randstr()
ip = getIP()



def validate():

	# Check if username is in valid form
	allowedchars = set(string.letters + string.digits + '_-')
	userchars = set(username)
	if len(username) > 24 or not userchars.issubset(allowedchars):
		raise BeeBBError, "Invalid Username."

	# Validate email
	validateEmail(email)

	# Check if username exists
	existinguser = list(bb_sql.User.selectBy(username=username))
	existingusertrial = list(bb_sql.TrialUser.selectBy(username=username))
	if existinguser or existingusertrial:
		raise BeeBBError, "Username exists:  Choose another one."

	# Check if email exists
	existingemail = list(bb_sql.User.selectBy(email=email))
	existingemailtrial = list(bb_sql.TrialUser.selectBy(email=email))
	if existingemail or existingemailtrial:
		raise BeeBBError, "Email address already exists."

	# Validate password
	validatePasswd(passwd)

	# Check if passwords match
	if not (passwd == confirm):
		raise BeeBBError, "Password mismatch"


# No POST vars at all
if not (username or email or passwd or confirm):
	website = bb_html.Register()

else:
	# Not all fields filled
	if not (username and email and passwd and confirm):
		website = bb_html.Register()
		website.addTop("Please fill-in <em>all</em> of the fields.", css="card")

	else:
		# Does everything look ok?
		try:
			validate()
		# Found a catch!
		except BeeBBError, e:
			website = bb_html.Register()
			website.addTop(unicode(e), css="error")
		# All _seems_ valid
		else:
			bb_sql.TrialUser(username=username, email=email, key=key, ip=ip, passwd=MD5(passwd))
			bb_mail.TrialUser(to_addr=email, key=key)
			website = bb_html.Generic(message="Thank you.  Check your email, and follow the instructions.")



# Print

website.send()
